
#pragma once

#include <string>
#include <list>

#if defined(_MSC_VER)
#  pragma warning(disable: 4065)  // "Switch statement contains 'default' but no 'case' labels"
#endif

namespace Orthanc {
namespace EmbeddedResources {

    enum FileResourceId
    {
      POSTGRESQL_PREPARE_INDEX,
      POSTGRESQL_UPGRADE_UNKNOWN_TO_REV1,
      POSTGRESQL_UPGRADE_REV1_TO_REV2,
      POSTGRESQL_UPGRADE_REV2_TO_REV3,
      POSTGRESQL_UPGRADE_REV3_TO_REV4
    };

    enum DirectoryResourceId
    {

    };

    const void* GetFileResourceBuffer(FileResourceId id);
    size_t GetFileResourceSize(FileResourceId id);
    void GetFileResource(std::string& result, FileResourceId id);

    const void* GetDirectoryResourceBuffer(DirectoryResourceId id, const char* path);
    size_t GetDirectoryResourceSize(DirectoryResourceId id, const char* path);
    void GetDirectoryResource(std::string& result, DirectoryResourceId id, const char* path);

    void ListResources(std::list<std::string>& result, DirectoryResourceId id);

}
}
